Attribute VB_Name = "ModDSOUND3D"
'This sample shows how to use the DSound functions in DirectX 8.
'
'
'To contact me: goodguy@t-online.de
'
'I DO NOT CLAIM ANY RIGHTS ON THIS LINES. USE IT, STEEL IT, MODIFY IT, DO WHATEVER YOU WANT!
'
'But - please let me know if you use it in your game! :)
'
'
'Benedikt Engelhard
'

Option Explicit



Public ds As DirectSound8 'Our DirectSound object

Global Const Max_Channels = 20 'The maximum number of simultanoes sounds
Public dsBuffer() As DirectSoundSecondaryBuffer8 ' DirectSoundSecondaryBuffer8 'Our SoundBuffers



Public dsBufferUsed As Integer 'What buffer's gotta be filled?



Public Sub Add3DSound(ByVal nFileName As String, Optional lFrequency, Optional lPan, Optional lVolume)

On Error Resume Next
'First let's search a free buffer
Dim nB As Long
dsBufferUsed = dsBufferUsed + 1
If dsBufferUsed > Max_Channels Then dsBufferUsed = 0
nB = dsBufferUsed

Dim dsBuf As DSBUFFERDESC
   
        'First clear the buffer
        If Not (dsBuffer(nB) Is Nothing) Then dsBuffer(nB).Stop
        Set dsBuffer(nB) = Nothing
     
        'Set some flags to the description
        dsBuf.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME
        On Error Resume Next
        'Load file into buffer
        Set dsBuffer(nB) = ds.CreateSoundBufferFromFile(nFileName, dsBuf)
        If Err Then
            LOG.LOG "Could not create soundbuffer (" & nFileName & ")"
            Exit Sub
        End If
        
        'If so, add "effects"
        'If Not IsMissing(lFrequency) Then dsBuffer(nB).SetFrequency lFrequency
        '100-100000
        
        'If Not IsMissing(lPan) Then dsBuffer(nB).SetPan lPan
        '-10000(left) 0(middle) +10000(right)
        
        'If Not IsMissing(lVolume) Then dsBuffer(nB).SetVolume lVolume
        '-2500 - 0
        

            'Alright? let's play!
            dsBuffer(nB).Play DSBPLAY_DEFAULT
End Sub


Public Function Init(dx As DirectX8, nhWnd As Long) As Boolean

    'This one initializes our DSound objects
    
    On Local Error Resume Next
    Set ds = dx.DirectSoundCreate(vbNullString) 'Create a default DirectSound object
    
    'We couldn't create the DSound object.  End the app now
    If Err.Number <> 0 Then
        MsgBox "Could not initialize DirectSound." & vbCrLf & "This program will exit.", vbOKOnly Or vbInformation, "Exiting..."
        
        Init = False
        Exit Function
    End If
    'Set the coop level
    ds.SetCooperativeLevel nhWnd, DSSCL_PRIORITY
    
        
    ReDim dsBuffer(0 To Max_Channels)
    
    
        
    Init = True
    LOG.LOG "ModDSOUND3D.Init successfully processed"
End Function

Public Sub Destroy()
    'This one kills our DS objects
On Error Resume Next
    Dim n As Integer
    
    For n = 0 To UBound(dsBuffer)
        Set dsBuffer(n) = Nothing 'argl!
    Next n
    
    
    Set ds = Nothing 'aarrghhh!!!
    
    LOG.LOG "ModDSOUND3D.Destroy successfully processed"  'Har har har...
    
End Sub

Sub LoadWaveFile(ByVal nFile As String, nDSB As DirectSoundSecondaryBuffer8)
Dim dsBuf As DSBUFFERDESC
   
        'Set some flags to the description
        dsBuf.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME
   Set nDSB = ds.CreateSoundBufferFromFile(nFile, dsBuf)
End Sub
